/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GetCampaignSendoutStarts200ResponseResults type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCampaignSendoutStarts200ResponseResults{}

// GetCampaignSendoutStarts200ResponseResults struct for GetCampaignSendoutStarts200ResponseResults
type GetCampaignSendoutStarts200ResponseResults struct {
	Id *string `json:"id,omitempty"`
	Type *string `json:"type,omitempty"`
	CampaignId *string `json:"campaign_id,omitempty"`
	CampaignSendoutId *string `json:"campaign_sendout_id,omitempty"`
	ContactConversations map[string]interface{} `json:"contact_conversations,omitempty"`
	CampaignSnapshot *int32 `json:"campaign_snapshot,omitempty"`
	EstimationCount *int32 `json:"estimation_count,omitempty"`
	ExecutionCount *int32 `json:"execution_count,omitempty"`
	RescheduleCount *int32 `json:"reschedule_count,omitempty"`
	MarketingOptOutCount *int32 `json:"marketing_opt_out_count,omitempty"`
	OptOutCount *int32 `json:"opt_out_count,omitempty"`
	UnreachableCount *int32 `json:"unreachable_count,omitempty"`
	Progress *int32 `json:"progress,omitempty"`
	EstimatedCostCents *int32 `json:"estimated_cost_cents,omitempty"`
	Result *GetCampaignSendoutStarts200ResponseResultsResult `json:"result,omitempty"`
}

// NewGetCampaignSendoutStarts200ResponseResults instantiates a new GetCampaignSendoutStarts200ResponseResults object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCampaignSendoutStarts200ResponseResults() *GetCampaignSendoutStarts200ResponseResults {
	this := GetCampaignSendoutStarts200ResponseResults{}
	return &this
}

// NewGetCampaignSendoutStarts200ResponseResultsWithDefaults instantiates a new GetCampaignSendoutStarts200ResponseResults object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCampaignSendoutStarts200ResponseResultsWithDefaults() *GetCampaignSendoutStarts200ResponseResults {
	this := GetCampaignSendoutStarts200ResponseResults{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetId(v string) {
	o.Id = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetType(v string) {
	o.Type = &v
}

// GetCampaignId returns the CampaignId field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignId() string {
	if o == nil || IsNil(o.CampaignId) {
		var ret string
		return ret
	}
	return *o.CampaignId
}

// GetCampaignIdOk returns a tuple with the CampaignId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignId) {
		return nil, false
	}
	return o.CampaignId, true
}

// HasCampaignId returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasCampaignId() bool {
	if o != nil && !IsNil(o.CampaignId) {
		return true
	}

	return false
}

// SetCampaignId gets a reference to the given string and assigns it to the CampaignId field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetCampaignId(v string) {
	o.CampaignId = &v
}

// GetCampaignSendoutId returns the CampaignSendoutId field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignSendoutId() string {
	if o == nil || IsNil(o.CampaignSendoutId) {
		var ret string
		return ret
	}
	return *o.CampaignSendoutId
}

// GetCampaignSendoutIdOk returns a tuple with the CampaignSendoutId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignSendoutIdOk() (*string, bool) {
	if o == nil || IsNil(o.CampaignSendoutId) {
		return nil, false
	}
	return o.CampaignSendoutId, true
}

// HasCampaignSendoutId returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasCampaignSendoutId() bool {
	if o != nil && !IsNil(o.CampaignSendoutId) {
		return true
	}

	return false
}

// SetCampaignSendoutId gets a reference to the given string and assigns it to the CampaignSendoutId field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetCampaignSendoutId(v string) {
	o.CampaignSendoutId = &v
}

// GetContactConversations returns the ContactConversations field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetContactConversations() map[string]interface{} {
	if o == nil || IsNil(o.ContactConversations) {
		var ret map[string]interface{}
		return ret
	}
	return o.ContactConversations
}

// GetContactConversationsOk returns a tuple with the ContactConversations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetContactConversationsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ContactConversations) {
		return map[string]interface{}{}, false
	}
	return o.ContactConversations, true
}

// HasContactConversations returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasContactConversations() bool {
	if o != nil && !IsNil(o.ContactConversations) {
		return true
	}

	return false
}

// SetContactConversations gets a reference to the given map[string]interface{} and assigns it to the ContactConversations field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetContactConversations(v map[string]interface{}) {
	o.ContactConversations = v
}

// GetCampaignSnapshot returns the CampaignSnapshot field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignSnapshot() int32 {
	if o == nil || IsNil(o.CampaignSnapshot) {
		var ret int32
		return ret
	}
	return *o.CampaignSnapshot
}

// GetCampaignSnapshotOk returns a tuple with the CampaignSnapshot field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetCampaignSnapshotOk() (*int32, bool) {
	if o == nil || IsNil(o.CampaignSnapshot) {
		return nil, false
	}
	return o.CampaignSnapshot, true
}

// HasCampaignSnapshot returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasCampaignSnapshot() bool {
	if o != nil && !IsNil(o.CampaignSnapshot) {
		return true
	}

	return false
}

// SetCampaignSnapshot gets a reference to the given int32 and assigns it to the CampaignSnapshot field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetCampaignSnapshot(v int32) {
	o.CampaignSnapshot = &v
}

// GetEstimationCount returns the EstimationCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetEstimationCount() int32 {
	if o == nil || IsNil(o.EstimationCount) {
		var ret int32
		return ret
	}
	return *o.EstimationCount
}

// GetEstimationCountOk returns a tuple with the EstimationCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetEstimationCountOk() (*int32, bool) {
	if o == nil || IsNil(o.EstimationCount) {
		return nil, false
	}
	return o.EstimationCount, true
}

// HasEstimationCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasEstimationCount() bool {
	if o != nil && !IsNil(o.EstimationCount) {
		return true
	}

	return false
}

// SetEstimationCount gets a reference to the given int32 and assigns it to the EstimationCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetEstimationCount(v int32) {
	o.EstimationCount = &v
}

// GetExecutionCount returns the ExecutionCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetExecutionCount() int32 {
	if o == nil || IsNil(o.ExecutionCount) {
		var ret int32
		return ret
	}
	return *o.ExecutionCount
}

// GetExecutionCountOk returns a tuple with the ExecutionCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetExecutionCountOk() (*int32, bool) {
	if o == nil || IsNil(o.ExecutionCount) {
		return nil, false
	}
	return o.ExecutionCount, true
}

// HasExecutionCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasExecutionCount() bool {
	if o != nil && !IsNil(o.ExecutionCount) {
		return true
	}

	return false
}

// SetExecutionCount gets a reference to the given int32 and assigns it to the ExecutionCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetExecutionCount(v int32) {
	o.ExecutionCount = &v
}

// GetRescheduleCount returns the RescheduleCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetRescheduleCount() int32 {
	if o == nil || IsNil(o.RescheduleCount) {
		var ret int32
		return ret
	}
	return *o.RescheduleCount
}

// GetRescheduleCountOk returns a tuple with the RescheduleCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetRescheduleCountOk() (*int32, bool) {
	if o == nil || IsNil(o.RescheduleCount) {
		return nil, false
	}
	return o.RescheduleCount, true
}

// HasRescheduleCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasRescheduleCount() bool {
	if o != nil && !IsNil(o.RescheduleCount) {
		return true
	}

	return false
}

// SetRescheduleCount gets a reference to the given int32 and assigns it to the RescheduleCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetRescheduleCount(v int32) {
	o.RescheduleCount = &v
}

// GetMarketingOptOutCount returns the MarketingOptOutCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetMarketingOptOutCount() int32 {
	if o == nil || IsNil(o.MarketingOptOutCount) {
		var ret int32
		return ret
	}
	return *o.MarketingOptOutCount
}

// GetMarketingOptOutCountOk returns a tuple with the MarketingOptOutCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetMarketingOptOutCountOk() (*int32, bool) {
	if o == nil || IsNil(o.MarketingOptOutCount) {
		return nil, false
	}
	return o.MarketingOptOutCount, true
}

// HasMarketingOptOutCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasMarketingOptOutCount() bool {
	if o != nil && !IsNil(o.MarketingOptOutCount) {
		return true
	}

	return false
}

// SetMarketingOptOutCount gets a reference to the given int32 and assigns it to the MarketingOptOutCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetMarketingOptOutCount(v int32) {
	o.MarketingOptOutCount = &v
}

// GetOptOutCount returns the OptOutCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetOptOutCount() int32 {
	if o == nil || IsNil(o.OptOutCount) {
		var ret int32
		return ret
	}
	return *o.OptOutCount
}

// GetOptOutCountOk returns a tuple with the OptOutCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetOptOutCountOk() (*int32, bool) {
	if o == nil || IsNil(o.OptOutCount) {
		return nil, false
	}
	return o.OptOutCount, true
}

// HasOptOutCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasOptOutCount() bool {
	if o != nil && !IsNil(o.OptOutCount) {
		return true
	}

	return false
}

// SetOptOutCount gets a reference to the given int32 and assigns it to the OptOutCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetOptOutCount(v int32) {
	o.OptOutCount = &v
}

// GetUnreachableCount returns the UnreachableCount field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetUnreachableCount() int32 {
	if o == nil || IsNil(o.UnreachableCount) {
		var ret int32
		return ret
	}
	return *o.UnreachableCount
}

// GetUnreachableCountOk returns a tuple with the UnreachableCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetUnreachableCountOk() (*int32, bool) {
	if o == nil || IsNil(o.UnreachableCount) {
		return nil, false
	}
	return o.UnreachableCount, true
}

// HasUnreachableCount returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasUnreachableCount() bool {
	if o != nil && !IsNil(o.UnreachableCount) {
		return true
	}

	return false
}

// SetUnreachableCount gets a reference to the given int32 and assigns it to the UnreachableCount field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetUnreachableCount(v int32) {
	o.UnreachableCount = &v
}

// GetProgress returns the Progress field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetProgress() int32 {
	if o == nil || IsNil(o.Progress) {
		var ret int32
		return ret
	}
	return *o.Progress
}

// GetProgressOk returns a tuple with the Progress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetProgressOk() (*int32, bool) {
	if o == nil || IsNil(o.Progress) {
		return nil, false
	}
	return o.Progress, true
}

// HasProgress returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasProgress() bool {
	if o != nil && !IsNil(o.Progress) {
		return true
	}

	return false
}

// SetProgress gets a reference to the given int32 and assigns it to the Progress field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetProgress(v int32) {
	o.Progress = &v
}

// GetEstimatedCostCents returns the EstimatedCostCents field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetEstimatedCostCents() int32 {
	if o == nil || IsNil(o.EstimatedCostCents) {
		var ret int32
		return ret
	}
	return *o.EstimatedCostCents
}

// GetEstimatedCostCentsOk returns a tuple with the EstimatedCostCents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetEstimatedCostCentsOk() (*int32, bool) {
	if o == nil || IsNil(o.EstimatedCostCents) {
		return nil, false
	}
	return o.EstimatedCostCents, true
}

// HasEstimatedCostCents returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasEstimatedCostCents() bool {
	if o != nil && !IsNil(o.EstimatedCostCents) {
		return true
	}

	return false
}

// SetEstimatedCostCents gets a reference to the given int32 and assigns it to the EstimatedCostCents field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetEstimatedCostCents(v int32) {
	o.EstimatedCostCents = &v
}

// GetResult returns the Result field value if set, zero value otherwise.
func (o *GetCampaignSendoutStarts200ResponseResults) GetResult() GetCampaignSendoutStarts200ResponseResultsResult {
	if o == nil || IsNil(o.Result) {
		var ret GetCampaignSendoutStarts200ResponseResultsResult
		return ret
	}
	return *o.Result
}

// GetResultOk returns a tuple with the Result field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) GetResultOk() (*GetCampaignSendoutStarts200ResponseResultsResult, bool) {
	if o == nil || IsNil(o.Result) {
		return nil, false
	}
	return o.Result, true
}

// HasResult returns a boolean if a field has been set.
func (o *GetCampaignSendoutStarts200ResponseResults) HasResult() bool {
	if o != nil && !IsNil(o.Result) {
		return true
	}

	return false
}

// SetResult gets a reference to the given GetCampaignSendoutStarts200ResponseResultsResult and assigns it to the Result field.
func (o *GetCampaignSendoutStarts200ResponseResults) SetResult(v GetCampaignSendoutStarts200ResponseResultsResult) {
	o.Result = &v
}

func (o GetCampaignSendoutStarts200ResponseResults) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCampaignSendoutStarts200ResponseResults) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.CampaignId) {
		toSerialize["campaign_id"] = o.CampaignId
	}
	if !IsNil(o.CampaignSendoutId) {
		toSerialize["campaign_sendout_id"] = o.CampaignSendoutId
	}
	if !IsNil(o.ContactConversations) {
		toSerialize["contact_conversations"] = o.ContactConversations
	}
	if !IsNil(o.CampaignSnapshot) {
		toSerialize["campaign_snapshot"] = o.CampaignSnapshot
	}
	if !IsNil(o.EstimationCount) {
		toSerialize["estimation_count"] = o.EstimationCount
	}
	if !IsNil(o.ExecutionCount) {
		toSerialize["execution_count"] = o.ExecutionCount
	}
	if !IsNil(o.RescheduleCount) {
		toSerialize["reschedule_count"] = o.RescheduleCount
	}
	if !IsNil(o.MarketingOptOutCount) {
		toSerialize["marketing_opt_out_count"] = o.MarketingOptOutCount
	}
	if !IsNil(o.OptOutCount) {
		toSerialize["opt_out_count"] = o.OptOutCount
	}
	if !IsNil(o.UnreachableCount) {
		toSerialize["unreachable_count"] = o.UnreachableCount
	}
	if !IsNil(o.Progress) {
		toSerialize["progress"] = o.Progress
	}
	if !IsNil(o.EstimatedCostCents) {
		toSerialize["estimated_cost_cents"] = o.EstimatedCostCents
	}
	if !IsNil(o.Result) {
		toSerialize["result"] = o.Result
	}
	return toSerialize, nil
}

type NullableGetCampaignSendoutStarts200ResponseResults struct {
	value *GetCampaignSendoutStarts200ResponseResults
	isSet bool
}

func (v NullableGetCampaignSendoutStarts200ResponseResults) Get() *GetCampaignSendoutStarts200ResponseResults {
	return v.value
}

func (v *NullableGetCampaignSendoutStarts200ResponseResults) Set(val *GetCampaignSendoutStarts200ResponseResults) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCampaignSendoutStarts200ResponseResults) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCampaignSendoutStarts200ResponseResults) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCampaignSendoutStarts200ResponseResults(val *GetCampaignSendoutStarts200ResponseResults) *NullableGetCampaignSendoutStarts200ResponseResults {
	return &NullableGetCampaignSendoutStarts200ResponseResults{value: val, isSet: true}
}

func (v NullableGetCampaignSendoutStarts200ResponseResults) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCampaignSendoutStarts200ResponseResults) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


